; prijme klavesovy kod i s casem
PRIJMOUT_	MACRO
	LOCAL	CEKEJ, TIME_REC, KEYLOOP, PRERUS
	CLRF	TIME	; vynulovani casoveho zaznamu
	CLRF	TIME+1
	DECFSZ	TIME,F	; toto je uprava pro pripad nekterych klavesnic a pocitacu...
	GOTO	$ - 1
	BTFSS	CLOCK	; ...musime zkontrolovat, jestli uz skoncila odezva z pocitace (linka je volna)
	GOTO	$ - 1
	CLRF	TMR0	; resetujeme casovac,...
	BCF	INTCON,T0IF ; ...ale v podstate to neni nijak dulezite
CEKEJ	BTFSS	KBREAK	; testovani ukonceni tlacitkem
	GOTO	PRERUS
	BTFSS	CLOCK	; cekame na prichod "hodin"
	GOTO	TIME_REC	
	BTFSS	INTCON,T0IF ; pokud neprichazi, testujeme preteceni casovace
	GOTO	CEKEJ
	BCF	INTCON,T0IF ; pokud casovac pretekl,...
	INCFSZ	TIME,F	; ... inkrementujeme softwarovy 14bitovy citac
	GOTO	CEKEJ
	INCF	TIME+1,F
	BTFSS	TIME+1,6
	GOTO	CEKEJ
	MOVLW	D'255'	; ...pokud i ten pretece, nastavime maximalni hodnotu
	MOVWF	TIME
	MOVLW	D'63'
	MOVWF	TIME+1
TIME_REC	NENUL_	TIME	; cas nesmi byt nulovy
	MOVLW	D'11'
	MOVWF	KEYCOUNT	; zacina cteni kodu klavesnice
KEYLOOP	BTFSC	CLOCK	; cekame na hodinovy pulz
	GOTO	$ - 1
	BCF	KEYKOD+1,3; prenos bitu z datoveho sig. do bufferu
	BTFSS	CLOCK	; - || -
	GOTO	$ - 1	; - || -
	BTFSC	KEYDATA	; - || -
	BSF	KEYKOD+1,3	; - || -
	RRF	KEYKOD+1,F	; - || -
	RRF	KEYKOD,F		; - || -
	DECFSZ	KEYCOUNT,F	; opakovani cyklu, dokud neni bitovy buffer plny
	GOTO	KEYLOOP
	MOVF	KEYKOD+1,W	; v 16bit. promenne KEYKOD je cely kod...
	ANDLW	B'00000111'	; ...ale musi se "ocistit"
	MOVWF	KEYKOD+1
	BCF	STATUS,Z	; indikace, ze byl precten novy kod
	RETURN
PRERUS	CLRF	TIME	; pokud byl zaznam prerusen tlacitkem,...
	CLRF	TIME+1	; ...bude vysledek nulovy,...
	BSF	STATUS,Z	; ...vcetne indikace, ze nebyl precten novy kod
	RETURN 
	ENDM

; generuje klavesovy kod
VYSLIKEY_	MACRO
	LOCAL	VYSLILOOP, K_ZEMI, VYSLSKOK
	MOVF	KKOD,W	; kopirovani KKOD do KEYKOD
	MOVWF	KEYKOD
	MOVF	KKOD+1,W
	MOVWF	KEYKOD+1 
	MOVLW	D'11'	; pocet bitu
	MOVWF	KEYCOUNT
	MOVLW	KEYMASK	; nastavime port pro simulaci...
	ANDWF	KEYPORT,F	; ...otevreneho kolektoru
VYSLILOOP	MOVLW	D'239'	; casovani jednoho obdelniku hodin
	MOVWF	TMR0
	BCF	INTCON,T0IF
	BTFSS	KEYKOD,0
	GOTO	K_ZEMI
	banksel	TRISC	; nastaveni hrany hodin a dat (v rezimu otevreneho kolektoru)
	BSF	KEYDATA
	BCF	CLOCK
	banksel	PORTC
	GOTO	VYSLSKOK
K_ZEMI	
	banksel	TRISC
	BCF	KEYDATA
	BCF	CLOCK
	banksel	PORTC
VYSLSKOK	BTFSS	INTCON,T0IF	; cekame na konec casovani obdelniku
	GOTO	$ - 1
	banksel	TRISC	; generujeme opacnou hranu hodin
	BSF	CLOCK
	banksel	PORTC
	MOVLW	D'239'	; nastavine casovani druheho obdelniku
	MOVWF	TMR0
	BCF	INTCON,T0IF
	RRF	KEYKOD+1,F	; posouvame obsah KEYKOD, abychom...
	RRF	KEYKOD,F		; ...meli pripraveny dalsi bit na kraji
	BTFSS	INTCON,T0IF	; cekame na konec casovani obdelniku
	GOTO	$ - 1
	DECFSZ	KEYCOUNT,F	; opakovani cyklu
	GOTO	VYSLILOOP
	banksel	TRISC
	BSF	KEYDATA	; deaktivujeme datovy signal
	banksel	PORTC
	RETURN 
	ENDM

; generovani casove prodlevy (nevyzaduje komentar)
CEKEJ_	MACRO
	LOCAL	CEKEJ2
	MOVF	KKOD,W
	XORLW	D'255'
	MOVWF	TIME
	MOVF	KKOD+1,W
	XORLW	D'255'
	MOVWF	TIME+1
	CLRF	TMR0
	BCF	INTCON,T0IF
CEKEJ2	BTFSS	INTCON,T0IF
	GOTO	CEKEJ2
	BCF	INTCON,T0IF
	INCFSZ	TIME,F
	GOTO	CEKEJ2
	INCFSZ	TIME+1,F
	GOTO	CEKEJ2
	RETURN
	ENDM
